/** @file
 * @brief TaskManager core module internal API
 * @ingroup TaskManager
 */

/** @defgroup TaskManager Core module: TaskManager -- the PadicoTM task manager
 * @author Alexandre Denis
 */

#ifndef PADICO_TM_INTERNALS_H
#define PADICO_TM_INTERNALS_H

#include "PadicoTM.h"
#include "PM2.h"
#include <assert.h>

__PUK_SYM_INTERNAL
void padico_tm_xml_init(void);
__PUK_SYM_INTERNAL
void padico_tm_xml_finalize(void);
__PUK_SYM_INTERNAL
void padico_tm_task_engine_init(void);
__PUK_SYM_INTERNAL
void padico_tm_task_engine_run(void);
__PUK_SYM_INTERNAL
void padico_tm_task_engine_cleanup(void);

__PUK_SYM_INTERNAL
void padico_tm_mod_process(padico_task_t task);

#endif
