#!/bin/bash

TESTSDIR=$1

NUMTEST=$(ls -1 ${TESTSDIR} | awk -F "_" '{print $1"_"$2}' | uniq | wc -l)

cat <<EOF
<center>
<table border=1>
<tr>
<th><font size=-2>TEST</font></th>
</tr>
EOF

cat <<EOF
<td>
<table border=1>
<tr>
<th><font size=-2>Date</font></th>
<th><font size=-2>Revision</font></th>
<th><font size=-2>Success</font></th>
<th><font size=-2>Failed</font></th>
</tr>
EOF

for (( i=1; i<=${NUMTEST}; i++ )); do
    REVDATE=$(ls -1 -r ${TESTSDIR} | awk -F "_" '{print $1"_"$2}' | uniq | sed -n "${i}p")
    DATE=$(echo ${REVDATE} | awk -F "_" '{print $1}')
    REVISION=$(echo ${REVDATE} | awk -F "_" '{print $2}')
    SUCCESS=$(cat ${TESTSDIR}/${REVDATE}* | grep "TEST_SUCCESS" | wc -l)
    FAILED=$(cat ${TESTSDIR}/${REVDATE}* | grep "TEST_FAILED" | wc -l)
    cat <<EOF
<tr>
  <td align=center><font size=-2>${DATE}</font></td>
  <td align=center><font size=-2>${REVISION}</font></td>
  <td align=center><font size=-2>${SUCCESS}</font></td>
  <td align=center><font size=-2>${FAILED}</font></td>
</tr>
EOF
    
done

cat <<EOF
</table>
</td>
</tr>
</table>
</center>
EOF
