dnl -*- mode: Autoconf;-*-

# ## add common makefiles to out list
AC_DEFUN([AC_PADICO_OUT_COMMON_MK],
	 [
	   AC_REQUIRE([AC_PADICO_BASE_TOOLS])
	   AC_REQUIRE([AC_PADICO_CDEP])
	   AC_REQUIRE([AC_PADICO_LINKER])
	   AC_REQUIRE([AC_PADICO_OPTIMIZE])
	   AC_REQUIRE([AC_PADICO_DEBUG])
	   AC_MSG_CHECKING([for common building-tools])
	   if test -r ${srcdir}/building-tools/common_rules.mk.in; then
	     building_tools=${srcdir}/building-tools/
	   elif test -r ${srcdir}/../building-tools/common_rules.mk.in; then
	     building_tools=${srcdir}/../building-tools/
 	   else
	     AC_MSG_ERROR([missing building-tools directory in srcdir: ${srcdir}])
	   fi
	   AC_MSG_RESULT([${building_tools}])
	   AC_SUBST([building_tools])
	   out_mk="common_vars.mk:${building_tools}/common_vars.mk.in ${out_mk}"
	   out_mk="common_rules.mk:${building_tools}/common_rules.mk.in ${out_mk}"
	  ])

# ## add root Makefile to out list
AC_DEFUN([AC_PADICO_OUT_ROOT],
	 [
	   out_mk="${out_mk} Makefile"
	   if test -r ${srcdir}/doc/Doxyfile.in; then
  	     out_mk="${out_mk} doc/Doxyfile"
	   fi
	   if test -r ${srcdir}/${package_short_name}.pc.in; then
	     out_mk="${out_mk} ${package_short_name}.pc"
	   fi
	 ])

# ## add a shell script to out list
AC_DEFUN([AC_PADICO_OUT_SH],
	 [
           AC_CONFIG_FILES( [ $1 ] , [ chmod +x $1 ])
	 ])

# ## issue output commands from out_mk lists
AC_DEFUN([AC_PADICO_OUTPUT],
	 [
	   AC_CONFIG_FILES([ ${out_mk} ])
	   AC_OUTPUT
	 ])
